      
AC_DEFUN(FIND_SEP_ARCH, [
                                                                                        
AC_MSG_CHECKING([Check SEP_ARCH])
                                                                                        
case "${build}" in
  powerpc-apple-darwin*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=MACOS ;;
  mips*-sgi-irix6*)
    SEP_ARCH=SGI64
    if test ${CC} != "gcc" ; then
      DEFINES="${DEFINES} -DSGI "
      LDFLAGS="${LDFLAGS} -64"
      FCLDFLAGS="${FCLDFLAGS} -64"
      CFLAGS="-64 -O2 ${CFLAGS}"
      FCFLAGS="-64 -O2 ${FCFLAGS} -extend_source"
    fi
  ;;
  mips*-sgi-irix*)
    SEP_ARCH=SGI ;;
  powerpc-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  ia64-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX64 ;;
  i386-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  i486-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  i586-*-linux*)
  OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  i686-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  *-*-cygwin)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=CYGWIN ;;
  *-*-solaris2*)
    OCPP="/usr/ccs/lib/cpp -P"
    SEP_ARCH=SOLARIS
    LIBS="-lsocket  -lnsl  -lgen -lintl -lw -lm  -lc  ${LIBS} "
  ;;
  *-*-sunos4*)
  SEP_ARCH=SUN4 ;;
  *-hp-hpux*)
    SEP_ARCH=HP700
    CPPFLAGS="${CPPFILAGS} -Ae -D_HPUX_SOURCE"
    LIBS="-lBSD -lcl -lnsl ${LIBS}"
    ;;
  rs6000-*-*)
    SEP_ARCH=RS600
#    AM_CONDITIONAL(RS6000,test  ${SEP_ARCH} = "RS6000")
    ;;
  *-convex-*)
    SEP_ARCH=CONVEX ;;
  *-cray-*)
    SEP_ARCH=CRAY ;;
  alpha-dec-*)
    SEP_ARCH=DECALPHA ;;
  *-dec-*)
    SEP_ARCH=DEC ;;
  *)
    SEP_ARCH=$build ;;
esac;
if test -z "$FCINCFLAG"; then
if test ${SEP_ARCH} = "SOLARIS" ; then
  FCINCFLAG="-M"
else
  FCINCFLAG="-I"
fi
fi
AC_MSG_RESULT([$SEP_ARCH])

AC_SUBST(SEP_ARCH)
                                                                                        
])

dnl AC_CHECK_FTYPE(fprog,CFFLAG,FLIBS,FDEFS)
                                                                                        
AC_DEFUN(AC_CHECK_FTYPE, [
  run_it=`echo "[$1] -version " `
  eval $run_it 1>/dev/null 2> in.v1
  run_it=`echo "[$1] --version " `
  eval $run_it 1>in.v2 2> in.v4
  run_it=`echo "[$1] -what " `
  eval $run_it 1>/dev/null 2> in.v3
  run_it=`echo "[$1] -V " `
  eval $run_it 1>in.v5 2> /dev/null
  run_it=`echo "[$1] -V " `
  eval $run_it 1>/dev/null 2>in.v6
  run_it=`echo "[$1] -dryrun " `
  eval $run_it 1>in.v7 2>/dev/null
  echo >> junk.f90
  run_it=`echo "[$1] -V junk.f90 " `
  eval $run_it 2>in.v8 1>/dev/null
  rm junk.f90
                                                                                        
  if test [$1] = fort77 -a  ${SEP_ARCH} = "LINUX" ; then
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok"
    $4="$[$4]   -lg2c -lm -lieee "
  fi
                                                                                        
                                                                                        
  if ( eval "grep -i ardent in.v4") ; then
    $2="$[$2] -DARDENT"
  fi
  if ( eval "grep -i ardent in.v2") ; then
   $2="$[$2] -DARDENT"
  fi
  if ( eval "grep -i ardent in.v1") ; then
    $2="$[$2] -DARDENT"
  fi
                                                                                        
  if ( eval "grep -i vast in.v7") ; then
    vastsiera=1
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lm -lieee "
                                                                                        
else
  if ( eval "grep -i numerical in.v1") ; then
    $2="$[$2] -DNAGf90Fortran"
    $3="$[$3] -free -mismatch"
else
  if ( eval "grep -i g77 in.v2") ; then
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lm -lieee "
  fi
  if ( eval "grep -i egcs in.v2") ; then
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lf2c -lm -lieee -lf2c"
  fi
  if ( eval "grep -i gcc in.v2") ; then
    $2="$[$2] -Dgnu"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lf2c -lm -lieee -lf2c"
  fi
  fi
                                                                                        
    if ( eval "grep -i absoft in.v8") ; then
#    $2="$[$2] -DAbsoftUNIXFortran"
    $2="$[$2] -DAbsoftProFortran"
    $4="$[$4] -lU77"
     FCINCFLAG="-p"
  fi
 if ( eval "grep -i intel in.v6") ; then
    $2="$[$2] -DpgiFortran"
    $4="$[$4]  -Vaxlib -lm"
  fi
  if ( eval "grep -i portland in.v5") ; then
    $2="$[$2] -DpgiFortran"
    $3="$[$3] -Kieee"
  fi
  if test ${SEP_ARCH} = "DEC" -o  ${SEP_ARCH} = "DECALPHA" ; then
    if ( eval "grep -i  DEC in.v3") ; then
     $2="$[$2] -DDECFortran"
   fi
  fi
  if ( eval "grep -i portland in.v5") ; then
    $2="$[$2] -DpgiFortran"
  fi
  if test ${SEP_ARCH} = "DECALPHA" ; then
    $4="$[$4] -lUfor -lfor -lFutil -lm -lots"
  fi
  if test ${SEP_ARCH} = "CRAY" ; then
    $3="$[$3]  -DSIGFNC_RTN_VOID -DUSG"
  fi
  if test ${SEP_ARCH} = "HP700" ; then
    $2="$[$2] -Dextname"
    $3="$[$3]  -v  +e +es  +ppu"
    $4="$[$4] -lBSD -lm -lcl -lc"
  fi
# if test ${SEP_ARCH} = "LINUX" ; then
#   $4="$[$4]  -lf2c -lm -lieee -lf2c"
# fi
#end of vast
fi
  rm  -f in.v1  in.v2 in.v3 in.v4 in.v5 in.v6 in.v7 in.v8
  ])
                                                                                        
                                                                                        
AC_DEFUN(SEP_FC, [
dnl FORTRANC COMPILER
if test $FC = "no" ; then
 AC_MSG_NOTICE(NO FORTRAN SUPPORT)
else
   AC_MSG_NOTICE(FORTRAN SUPPORT)
  FCPFLAGS="${FCPFLAGS} ${DEFINES}  "
  FCSOURCE="-DSOURCE='\"'\${FULLSRC}/\$(notdir \$<)'\"'"
  AC_SUBST(FCPFLAGS)
  AC_CHECK_FTYPE(${FC},CFCDEFINES,FCDEFINES,FCLIBS)
  SUBDIRS="$SUBDIRS \${FCDIR_DISTR}"
  bin_PROGRAMS="$bin_PROGRAMS \${FCPROG_DISTR}"
  lib_LIBRARIES="$lib_LIBRARIES \${FCLIB_DISTR}"
  if test $COMPILE_LEVEL = "LOCAL" ; then
    bin_PROGRAMS="$bin_PROGRAMS \${FCPROG_LOCAL}"
    SUBDIRS="$SUBDIRS \${FCDIR_LOCAL}"
    lib_LIBRARIES="$lib_LIBRARIES \${FCLIB_LOCAL}"
  fi
AC_SUBST(FC)
AC_MODULE_EXTENSIONS_FC
AC_SUBST(lib_LIBRARIES)
FCLD="${FC} ${FCLDFLAGS}"
FC="${FC} ${FCFLAGS}"
FCLIBS="${FCLIBS} ${LIBS}"
FCLDFLAGS="${FCLDFLAGS} \${LDFLAGS}"
AC_SUBST(FCINCFLAG)
AC_SUBST(FCLDFLAGS)
AC_SUBST(FCFLAGS)
AC_SUBST(FCLD)
AC_SUBST(CFCDEFINES)
AC_SUBST(FCDEFINES)
AC_SUBST(FCLIBS)
fi
])
AC_DEFUN(AC_MODULE_EXTENSIONS_FC,
[dnl
AC_MSG_CHECKING([which extensions compiling a module with ($FC) generates])
AC_LANG_SAVE
AC_LANG(Fortran)

                                                                                                           
cat > conftest.$ac_ext <<EOF
module conftest
end module conftest
EOF
AC_TRY_EVAL(ac_compile)
                                                                                                           
changequote(, )dnl
FCMODEXT=`echo *conftest* CONFTEST* | sed \
-e "s/[a-zA-Z]*conftest//g" \
-e "s/CONFTEST//g" \
-e "s/\.$ac_ext//g" \
-e "s/\.$ac_objext//g" \
-e "s/\*//g" \
`
changequote([, ])dnl
                                                                                                           
AC_MSG_RESULT(`echo "$FCMODEXT"`)
FCMODEXT=`echo "$FCMODEXT" | sed 's/\./*./g'`
rm -f *conftest* CONFTEST*
AC_LANG_RESTORE
AC_SUBST(FCMODEXT)
])



AC_DEFUN(MAKE_GMAKE,[
                                                                                        
  AC_CHECK_PROGS(MAKE, gmake make, make)
  run_it=`echo "${MAKE} -v " `
  eval $run_it 1>in.v1 2>in.v2
  if ( eval "grep -i gnu in.v1") ; then
    echo "USING GMAKE"
    rm -f in.v1 in.v2
  else
    echo "Require GNU Make"
    rm -f in.v1 in.v2
    exit 1;
  fi
])

AC_DEFUN(SEP_LIB_DEFS,[
SEPLIB="-lsep"
AC_SUBST(SEPLIB)
SEPLIBF90="-lsepf90 -lsep \${F90LIBS}"
AC_SUBST(SEPLIBF90)
SEPLIB3D="-lsep3d ${SEPLIB}"
AC_SUBST(SEPLIB3D)
SEPLIB3DF90="-lsep3df90 -lsep3d ${SEPLIBF90}"
AC_SUBST(SEPLIB3DF90)
SEPLIB2DF90="-lsep2df90 ${SEPLIB3DF90}"
AC_SUBST(SEPLIB2DF90)
SUPERSET="-lsuperset ${SEPLIB3D}"
AC_SUBST(SUPERSET)
SUPERSETF90="-lsupersetf90 -lsuperset ${SEPLIB3DF90}"
AC_SUBST(SUPERSETF90)
GEEF90="-lsepgeef90"
SEPGEEF90="-lsepgeef90"
AC_SUBST(SEPGEEF90)
AC_SUBST(GEEF90)
VPLOT="-lvplot"
AC_SUBST(VPLOT)
VPLOTF90="-lvplotf90 -lvplot "
AC_SUBST(VPLOTF90)
GLPLOT="-lglplot"
AC_SUBST(GLPLOT)
SEPAUX="-lsepaux"
SEPAUXF90="-lsepauxf90 -lsepaux"
SEPCONVERT="-lsepconvert"
SEPCONVERTF90="-lsepconvertf90 -lsepconvert"
SEPFFT="-lsepfft -lsepfftf90 -lsepfft \${SEPMATH}"
SEPFFTF90="-lsepfftf90  -lsepfft -lsepfftf90  -lsepfft ${SEPAUXF90}"
SEPCWP="-lsepcwp"
SEPMATH="-lsepmath"
SEPMATHF90="-lsepmathf90"
SEPVECTOR="-lsepvector"
SEPVECTORF90="-lsepvectorf90 -lsepvector"
AC_SUBST(SEPCWP)
AC_SUBST(SEPMATH)
AC_SUBST(SEPMATH)
AC_SUBST(SEPMATHF90)
AC_SUBST(SEPAUX)
AC_SUBST(SEPAUXF90)
AC_SUBST(SEPFFT)
AC_SUBST(SEPFFTF90)
AC_SUBST(SEPCONVERT)
AC_SUBST(SEPCONVERTF90)
AC_SUBST(SEPVECTOR)
AC_SUBST(SEPVECTORF90)
SEPTRAVEL="-lseptravel -lsepaux"
SEPTRAVELF90="-lseptravelf90 -lseptravel"
SEPVELANF90="-lsepvelanf90 ${SEPMATHF}"
SEPFILTERF90="-lsepfilterf90 ${SEPVECTORF90}"
SEPFILTER="-lsepfilter"
SEPDIPF90="-lsepdipf90 ${SEPFILTERF90} ${SEPGEEF90}"
AC_SUBST(SEPDIPF90)
AC_SUBST(SEPFILTERF90)
AC_SUBST(SEPFILTER)
AC_SUBST(SEPTRAVEL)
AC_SUBST(SEPTRAVELF90)
AC_SUBST(SEPVELANF90)
AC_SUBST(SEPFILTERF90)
])


                                                                                        
dnl
dnl Check if Motif is here somewhere
dnl

AC_DEFUN(AC_PATH_MOTIF_DIRECT,
[test -z "$motif_direct_test_library" && motif_direct_test_library=Xm
test -z "$motif_direct_test_function" && motif_direct_test_function=XmCreatePushButton
test -z "$motif_direct_test_include" && motif_direct_test_include=Xm/Xm.h
  for ac_dir in               \
    /usr/include/Motif1.2     \
    /usr/Motif1.2/include     \
                              \
    /usr/lesstif20/include    \
    /usr/lesstif/include      \
                              \
    /usr/lesstif*/include     \
                              \
    /usr/motif/include        \
                              \
    /usr/X11R6/include        \
    /usr/X11R5/include        \
                              \
    /usr/include/X11R6        \
    /usr/include/X11R5        \
                              \
    /usr/local/X11R6/include  \
    /usr/local/X11R5/include  \
                              \
    /usr/local/include/X11R6  \
    /usr/local/include/X11R5  \
                              \
    /usr/X11/include          \
    /usr/include/X11          \
    /usr/local/X11/include    \
    /usr/local/include/X11    \
                              \
    /usr/X386/include         \
    /usr/x386/include         \
    /usr/XFree86/include/X11  \
                              \
    /usr/dt/include           \
    /usr/openwin/include      \
    /opt/openwin/include      \
                              \
    /usr/include              \
    /usr/local/include        \
    /usr/unsupported/include  \
    /usr/athena/include       \
    /usr/local/x11r5/include  \
    /usr/lpp/Xamples/include  \
    ; \
  do
    if test -r "$ac_dir/$motif_direct_test_include"; then
      no_motif= ac_motif_includes=$ac_dir
      break
    fi
  done

# Check for the libraries.
# See if we find them without any special options.
# Don't add to $LIBS permanently.
ac_save_LIBS="$LIBS"
LIBS="-l$motif_direct_test_library $LIBS"
# First see if replacing the include by lib works.
for ac_dir in `echo "$ac_motif_includes" | sed s/include/lib/` \
    /usr/lib/Motif1.2     \
    /usr/Motif1.2/lib     \
                          \
    /usr/motif/lib        \
                          \
    /usr/X11R6/lib        \
    /usr/X11R5/lib        \
                          \
    /usr/lib/X11R6        \
    /usr/lib/X11R5        \
                          \
    /usr/local/X11R6/lib  \
    /usr/local/X11R5/lib  \
                          \
    /usr/local/lib/X11R6  \
    /usr/local/lib/X11R5  \
                          \
    /usr/X11/lib          \
    /usr/lib/X11          \
    /usr/local/X11/lib    \
                          \
    /usr/X386/lib         \
    /usr/x386/lib         \
    /usr/XFree86/lib/X11  \
                          \
    /usr/dt/lib           \
    /usr/openwin/lib      \
    /opt/openwin/lib      \
                          \
    /usr/lib              \
    /usr/local/lib        \
    /usr/unsupported/lib  \
    /usr/athena/lib       \
    /usr/local/x11r5/lib  \
    /usr/lpp/Xamples/lib  \
    ; \
do
  for ac_extension in a so sl; do
    if test -r $ac_dir/lib${motif_direct_test_library}.$ac_extension; then
      no_motif= ac_motif_libraries=$ac_dir
      break 2
    fi
  done
done
LIBS=$ac_save_LIBS])

AC_DEFUN(AC_PATH_MOTIF,
[AC_REQUIRE_CPP()dnl

motif_includes=NONE
motif_libraries=NONE

AC_MSG_CHECKING(for Motif)
AC_ARG_WITH(motif, [  --with-motif            enable Motif tests])
if test "x$with_motif" = xno; then
  no_motif=yes
else
  if test "x$motif_includes" != xNONE && test "x$motif_libraries" != xNONE; then
    no_motif=
  else
AC_CACHE_VAL(ac_cv_path_motif,
[# One or both of these vars are not set, and there is no cached value.
no_motif=yes
AC_PATH_MOTIF_DIRECT

if test "$no_motif" = yes; then
  ac_cv_path_motif="no_motif=yes"
else
  ac_cv_path_motif="no_motif= ac_motif_includes=$ac_motif_includes ac_motif_libraries=$ac_motif_libraries"
fi])dnl
  fi
  eval "$ac_cv_path_motif"
fi # with_motif != no

if test "$no_motif" = yes; then
  AC_MSG_RESULT(no)
else
  test "x$motif_includes" = xNONE && motif_includes=$ac_motif_includes
  test "x$motif_libraries" = xNONE && motif_libraries=$ac_motif_libraries
  ac_cv_path_motif="no_motif= ac_motif_includes=$motif_includes ac_motif_libraries=$motif_libraries"
  AC_MSG_RESULT([libraries $motif_libraries, headers $motif_includes])
  CFLAGS="${CFLAGS}  -I$motif_includes"
  LIBS="${LIBS} -L$motif_libraries -lXm"
  AC_PATH_XTRA
fi
])

