
AC_DEFUN(FIND_SEP_ARCH, [
                                                                                        
                                                                                        
case "${build}" in
  powerpc-apple-darwin*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=MACOS ;;
  mips*-sgi-irix6*)
    SEP_ARCH=SGI64
    if test ${CC} != "gcc" ; then
      DEFINES="${DEFINES} -DSGI "
      LDFLAGS="${LDFLAGS} -64"
      CFLAGS="-64 -O2 ${CFLAGS}"
      FCFLAGS="-64 -O2 ${FCFLAGS} -extend_source"
    fi
  ;;
  mips*-sgi-irix*)
    SEP_ARCH=SGI ;;
  powerpc-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  ia64-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX64 ;;
  i386-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  i486-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  i586-*-linux*)
  OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  i686-*-linux*)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=LINUX ;;
  *-*-cygwin)
    OCPP="/lib/cpp -P -traditional"
    SEP_ARCH=CYGWIN ;;
  *-*-solaris2*)
    OCPP="/usr/ccs/lib/cpp -P"
    SEP_ARCH=SOLARIS
    LIBS="-lsocket  -lnsl  -lgen -lintl -lw -lm  -lc  ${LIBS} "
  ;;
  *-*-sunos4*)
  SEP_ARCH=SUN4 ;;
  *-hp-hpux*)
    SEP_ARCH=HP700
    CPPFLAGS="${CPPFILAGS} -Ae -D_HPUX_SOURCE"
    LIBS="-lBSD -lcl -lnsl ${LIBS}"
    ;;
  rs6000-*-*)
    SEP_ARCH=RS600
#    AM_CONDITIONAL(RS6000,test  ${SEP_ARCH} = "RS6000")
    ;;
  *-convex-*)
    SEP_ARCH=CONVEX ;;
  *-cray-*)
    SEP_ARCH=CRAY ;;
  alpha-dec-*)
    SEP_ARCH=DECALPHA ;;
  *-dec-*)
    SEP_ARCH=DEC ;;
  *)
    SEP_ARCH=$build ;;
esac;
if test -z "$FCINCFLAG"; then
if test ${SEP_ARCH} = "SOLARIS" ; then
  FCINCFLAG="-M"
else
  FCINCFLAG="-I"
fi
fi
AC_SUBST(SEP_ARCH)
                                                                                        
])

dnl AC_CHECK_FTYPE(fprog,CFFLAG,FLIBS,FDEFS)
                                                                                        
AC_DEFUN(AC_CHECK_FTYPE, [
  run_it=`echo "[$1] -version " `
  eval $run_it 1>/dev/null 2> in.v1
  run_it=`echo "[$1] --version " `
  eval $run_it 1>in.v2 2> in.v4
  run_it=`echo "[$1] -what " `
  eval $run_it 1>/dev/null 2> in.v3
  run_it=`echo "[$1] -V " `
  eval $run_it 1>in.v5 2> /dev/null
  run_it=`echo "[$1] -V " `
  eval $run_it 1>/dev/null 2>in.v6
  run_it=`echo "[$1] -dryrun " `
  eval $run_it 1>in.v7 2>/dev/null
  echo >> junk.f90
  run_it=`echo "[$1] -V junk.f90 " `
  eval $run_it 2>in.v8 1>/dev/null
  rm junk.f90
                                                                                        
  if test [$1] = fort77 -a  ${SEP_ARCH} = "LINUX" ; then
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok"
    $4="$[$4]   -lg2c -lm -lieee "
  fi
                                                                                        
                                                                                        
  if ( eval "grep -i ardent in.v4") ; then
    $2="$[$2] -DARDENT"
  fi
  if ( eval "grep -i ardent in.v2") ; then
   $2="$[$2] -DARDENT"
  fi
  if ( eval "grep -i ardent in.v1") ; then
    $2="$[$2] -DARDENT"
  fi
                                                                                        
  if ( eval "grep -i vast in.v7") ; then
    vastsiera=1
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lm -lieee "
                                                                                        
else
  if ( eval "grep -i numerical in.v1") ; then
    $2="$[$2] -DNAGf90Fortran"
    $3="$[$3] -free -mismatch"
else
  if ( eval "grep -i g77 in.v2") ; then
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lm -lieee "
  fi
  if ( eval "grep -i egcs in.v2") ; then
    $2="$[$2] -Dgnu -Df2cFortran"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lf2c -lm -lieee -lf2c"
  fi
  if ( eval "grep -i gcc in.v2") ; then
    $2="$[$2] -Dgnu"
    $3="$[$3]   -ffixed-line-length-none -ff90 -fdollar-ok -fargument-noalias -fno-globals "
    $4="$[$4]  -lf2c -lm -lieee -lf2c"
  fi
  fi
                                                                                        
    if ( eval "grep -i absoft in.v8") ; then
#    $2="$[$2] -DAbsoftUNIXFortran"
    $2="$[$2] -DAbsoftProFortran"
     FCINCFLAG="-p"
  fi
 if ( eval "grep -i intel in.v6") ; then
    $2="$[$2] -DpgiFortran"
    $4="$[$4]  -Vaxlib -lm"
  fi
  if ( eval "grep -i portland in.v5") ; then
    $2="$[$2] -DpgiFortran"
    $3="$[$3] -Kieee"
  fi
  if test ${SEP_ARCH} = "DEC" -o  ${SEP_ARCH} = "DECALPHA" ; then
    if ( eval "grep -i  DEC in.v3") ; then
     $2="$[$2] -DDECFortran"
   fi
  fi
  if ( eval "grep -i portland in.v5") ; then
    $2="$[$2] -DpgiFortran"
  fi
  if test ${SEP_ARCH} = "DECALPHA" ; then
    $4="$[$4] -lUfor -lfor -lFutil -lm -lots"
  fi
  if test ${SEP_ARCH} = "CRAY" ; then
    $3="$[$3]  -DSIGFNC_RTN_VOID -DUSG"
  fi
  if test ${SEP_ARCH} = "HP700" ; then
    $2="$[$2] -Dextname"
    $3="$[$3]  -v  +e +es  +ppu"
    $4="$[$4] -lBSD -lm -lcl -lc"
  fi
# if test ${SEP_ARCH} = "LINUX" ; then
#   $4="$[$4]  -lf2c -lm -lieee -lf2c"
# fi
#end of vast
fi
  rm  -f in.v1  in.v2 in.v3 in.v4 in.v5 in.v6 in.v7 in.v8
  ])
                                                                                        
                                                                                        
AC_DEFUN(SEP_FC, [
dnl FORTRANC COMPILER
if test $FC = "no" ; then
 AC_MSG_NOTICE(NO FORTRAN SUPPORT)
else
   AC_MSG_NOTICE(FORTRAN SUPPORT)
  FCPFLAGS="${FCPFLAGS} ${DEFINES}  "
  FCSOURCE="-DSOURCE='\"'\${FULLSRC}/\$(notdir \$<)'\"'"
  AC_SUBST(FCPFLAGS)
  AC_CHECK_FTYPE(${FC},CFCDEFINES,FCDEFINES,FCLIBS)
  SUBDIRS="$SUBDIRS \${FCDIR_DISTR}"
  bin_PROGRAMS="$bin_PROGRAMS \${FCPROG_DISTR}"
  lib_LIBRARIES="$lib_LIBRARIES \${FCLIB_DISTR}"
  if test $COMPILE_LEVEL = "LOCAL" ; then
    bin_PROGRAMS="$bin_PROGRAMS \${FCPROG_LOCAL}"
    SUBDIRS="$SUBDIRS \${FCDIR_LOCAL}"
    lib_LIBRARIES="$lib_LIBRARIES \${FCLIB_LOCAL}"
  fi
AC_SUBST(FC)
AC_MODULE_EXTENSIONS_FC
AC_SUBST(lib_LIBRARIES)
FCLIBS="${FCLIBS} ${LIBS}"
FCLDFLAGS="${FCLDFLAGS} \${LDFLAGS}"
AC_SUBST(FCINCFLAG)
AC_SUBST(FCLDFLAGS)
AC_SUBST(FCFLAGS)
AC_SUBST(FCLD)
AC_SUBST(CFCDEFINES)
AC_SUBST(FCDEFINES)
AC_SUBST(FCLIBS)
fi
])
AC_DEFUN(AC_MODULE_EXTENSIONS_FC,
[dnl
AC_MSG_CHECKING([which extensions compiling a module with ($FC) generates])
AC_LANG_SAVE
AC_LANG(Fortran)

                                                                                                           
cat > conftest.$ac_ext <<EOF
module conftest
end module conftest
EOF
AC_TRY_EVAL(ac_compile)
                                                                                                           
changequote(, )dnl
FCMODEXT=`echo *conftest* CONFTEST* | sed \
-e "s/[a-zA-Z]*conftest//g" \
-e "s/CONFTEST//g" \
-e "s/\.$ac_ext//g" \
-e "s/\.$ac_objext//g" \
-e "s/\*//g" \
`
changequote([, ])dnl
                                                                                                           
AC_MSG_RESULT(`echo "$FCMODEXT"`)
FCMODEXT=`echo "$FCMODEXT" | sed 's/\./*./g'`
rm -f *conftest* CONFTEST*
AC_LANG_RESTORE
AC_SUBST(FCMODEXT)
])



AC_DEFUN(MAKE_GMAKE,[
                                                                                        
  AC_CHECK_PROGS(MAKE, gmake make, make)
  run_it=`echo "${MAKE} -v " `
  eval $run_it 1>in.v1 2>in.v2
  if ( eval "grep -i gnu in.v1") ; then
    echo "USING GMAKE"
    rm -f in.v1 in.v2
  else
    echo "Require GNU Make"
    rm -f in.v1 in.v2
    exit 1;
  fi
])


                                                                                        

