!<
! aamig
!
! USAGE
! call aamig( adj,add, slow,antialias,t0,dt, dx, nt,nx, image, data)
!
! DESCRIPTION
! anti-aliased kirchhoff migration (adj=1) and modeling (adj=0)
!
! INPUT PARAMETERS
! adj       - integer   forward=0, adjoint=1
! add       - integer   add=1 (add to output), add=0 (erase output)
! slow      - real(nt)  slowness
! antialias - real      antialias length
! t0        - real      first sample time
! dt        - real      sampling in time
! nt        - integer   number of time samples
! nx        - integer   number of samples in x
! image     - real(nt,nx)  model
! data      - real(nt,nx)  data
!
! CATEGORY
! Lib:Image
!
! COMPILE LEVEL
! DISTR
!
!>
!
subroutine aamig( adj,add, slow,antialias,t0,dt, dx, nt,nx, image, data&
  &  )
integer adj, add, ix, nx, nt, iy
real    h,            slow(nt),antialias,t0,dt, dx, image(nt,nx), data&
  &(nt,nx)
call adjnull(    adj, add,                          image,nt*nx,  data&
  &,nt*nx)
do ix= 1, nx  
  do iy= 1, nx  
    h  = dx * (iy - ix)
    call trimo( adj, 1, t0,dt,dx, h, nt,slow, 0., 1., antialias,      &
      &                                                   image(1,iy&
      &), data(1,ix))
  end do
end do 
return
end  
