/*$

=head1 NAME

In3d - info in seplib datasets

=head1 SYNOPSIS

In3d header.H [header2.H .....] [pars]


=head1 Input parameters

=over 4


=item  keys- character  

       [y] print out header keys

=item   maxkeys - integer 

        [number of keys] maximum number of keys to print

=item   grid character 

        [y]  print grid axis if they exist

=item    check character

        [y]  check for zeros in file

=item  dff- character  

       [n] print out dff info

=item   maxkeys - integer 

        [nkeys] Number of keys to print

=back

=head1 DESCRIPTION 

Provide  useful information about SEP3d datasets

=head1 SEE ALSO

L<In>, L<Attr>, L<Attr3dhead>

=head1 CATEGORY

B<util/info>

=cut
>*/
/*
Author:Robert G. Clapp

9/18/95 Begun
4/17/97 Added data_format and esize to output, need to deal with vplot
        Should just not call filesize
7/5/97  Changed the way number of data axes is calculated to new standard
6/2/99  Bob-Begun change to GNU standard 
*/
#define         HEAD    "/dev/null"
#define         OUT    "/dev/null"
/*#include <sep.main>*/
/*#include <seplib.h>*/
#include <sitedef.h>
#include <sys/types.h>
#include <string.h>
#include <seplib.h>
#include <sys/file.h>
#include <sys/stat.h>

#if defined (HAVE_STDLIB_H)
#include<stdlib.h>
#else
extern int atoi();
#endif /* HAVE_STDLIB  */
#define STRING_SIZE 10024
    char zero_check[9];

int dff_tag;

/*MAIN()*/
main (argc, argv)
int argc;
char *argv[];
{
    int esize,n,i2,tempi,temp2i,n1;
    float d,o;
    int i1,ierr,logic1,logic2,count1,count2,mark,type;
		double size;
    int n1h,n_axis,logic,maxkeys,compress;
    char label[STRING_SIZE],temp_ch[STRING_SIZE],temp2_ch[STRING_SIZE],keytype[256],keyname[256],keyformat[256];
    char charn[20],charo[20],chard[20],dfftag[STRING_SIZE];
    char keys[10],grid[10],dodff[30],temp3_ch[STRING_SIZE];
    char files[99][256],left[10][99],right[10][99];

initpar( argc, argv ) ;
count1=0;
count2=0;
sep_add_doc_line("NAME");
sep_add_doc_line("    In3d - info in seplib datasets");
sep_add_doc_line("");
sep_add_doc_line("SYNOPSIS");
sep_add_doc_line("    In3d header.H [header2.H .....] [pars]");
sep_add_doc_line("");
sep_add_doc_line("Input parameters");
sep_add_doc_line("    keys- character");
sep_add_doc_line("               [y] print out header keys");
sep_add_doc_line("");
sep_add_doc_line("    maxkeys - integer");
sep_add_doc_line("                [number of keys] maximum number of keys to print");
sep_add_doc_line("");
sep_add_doc_line("    grid character");
sep_add_doc_line("                [y]  print grid axis if they exist");
sep_add_doc_line("");
sep_add_doc_line("    check character");
sep_add_doc_line("                [y]  check for zeros in file");
sep_add_doc_line("");
sep_add_doc_line("    dff- character");
sep_add_doc_line("               [n] print out dff info");
sep_add_doc_line("");
sep_add_doc_line("    maxkeys - integer");
sep_add_doc_line("                [nkeys] Number of keys to print");
sep_add_doc_line("");
sep_add_doc_line("DESCRIPTION");
sep_add_doc_line("    Provide useful information about SEP3d datasets");
sep_add_doc_line("");
sep_add_doc_line("SEE ALSO");
sep_add_doc_line("    In, Attr, Attr3dhead");
sep_add_doc_line("");
sep_add_doc_line("CATEGORY");
sep_add_doc_line("    util/info");
sep_add_doc_line("");

doc (SOURCE);
for (i2=1;i2<argc;i2++){
  logic=0;
  for (i1=0;argv[i2][i1]!='\0';i1++){
     if(logic!=1){
        temp_ch[i1]=argv[i2][i1];
        if(argv[i2][i1]=='='){
           temp_ch[i1]='\0';
           strcpy(left[count2],temp_ch); 
           logic=1;
           mark=0;
         }
      }
      else{
         right[count2][mark]=argv[i2][i1];
	 mark++;
      }
    }
    if (logic!=1){
      strcpy(files[count1],argv[i2]);
      count1++;
    }
    else {
	right[count2][mark]='\0' ;
           count2++;
    }
}


 strcpy(zero_check,"yes");
for(i1=0;i1<count2;i1++){
  if(!strcmp("check",left[i1])) strcpy(zero_check,right[i1]); 
}
strcpy(dodff,"y");
for(i1=0;i1<count2;i1++){
  if(!strcmp("dff",left[i1])) strcpy(dodff,right[i1]); 
}

logic=0;
for (i2=0;i2<count1;i2++){
if (!auxpar("in","s",label,files[i2])){
  fprintf(stderr,"%s: not a valid history file \n",files[i2]);
  auxclose(files[i2]);
 }
 else{
 dff_tag=0;
  if(1==auxpar("dff","s",dfftag,files[i2])){ dff_tag=1;
    if(0==strcmp(dfftag,"-1")) dff_tag=0;
  }
  fprintf(stderr,"-----------------------------------------------------------------\n");
  fprintf(stderr,"\t \t ********** %s ************ \n",files[i2]);
    if (!auxpar("esize","d",&tempi,files[i2])) tempi=4;
		if (!auxpar("hff","s",label,files[i2])){ strcpy(label,"-1"); }
		if(label[0]!='-' || label[1]!='1' ){
    	if (!auxpar("same_record_number","d",&temp2i,files[i2])) temp2i=1;
		}
		else {temp2i=-1; }
    if (!auxpar("data_format","s",temp_ch,files[i2])){
			if(tempi==4)  strcpy(temp_ch,"native_float"); 
			else if(tempi==1)  strcpy(temp_ch,"native_byte"); 
			else if(tempi==-1)  strcpy(temp_ch,"vplot"); 
			else if(tempi==3)  strcpy(temp_ch,"triples"); 
		}
	if(temp2i==-1) 
		fprintf(stderr,"          %d -esize                           data_format-%s \n",tempi,temp_ch);
	else if(temp2i==0)
		fprintf(stderr,"          %d -esize          Unsynched        data_format-%s \n",tempi,temp_ch);
	else
		fprintf(stderr,"          %d -esize          Synched          data_format-%s \n",tempi,temp_ch);
	
  fprintf(stderr,"-----------------------------------------------------------------\n");
 size=1.;
 logic=0;
	ierr=sep_get_number_data_axes(files[i2],&tempi);
	for(i1=1; i1 <= tempi; i1++){
    sprintf(temp_ch,"%c%d",'n',i1);
		if (!auxpar(temp_ch,"d",&n,files[i2])) n=1;
    size=size*n;
		if(i1==1) n1=n;
    sprintf(charn,"%d",n);
    sprintf(temp_ch,"%c%d",'o',i1);
    if (!auxpar(temp_ch,"f",&o,files[i2])) strcpy(charo,"0?     "); 
    else sprintf(charo,"%f",o);
    charo[9]='\0';
    sprintf(temp_ch,"%c%d",'d',i1);
    if (!auxpar(temp_ch,"f",&d,files[i2])) strcpy(chard,"1?     "); 
    else sprintf(chard,"%f",d);
    chard[9]='\0';
    sprintf(temp_ch,"%s%d","label",i1);
    if (!auxpar(temp_ch,"s",label,files[i2])) label[0]='\0';
    if(n>99999)
               fprintf(stderr,"n%d=%s \t o%d=%s \t d%d=%s \t label%d=%s \n",
	  i1,charn,i1,charo,i1,chard,i1,label);
    else
               fprintf(stderr,"n%d=%s \t \t o%d=%s \t d%d=%s \t label%d=%s \n",
	  i1,charn,i1,charo,i1,chard,i1,label);
}
type=1;
	
	if(0==auxpar("esize","d",&esize,files[i2])) esize=4;
	ierr=filesize(files[i2],size/n1,esize*n1,1);

fprintf(stderr,"-----------------------------------------------------------------\n");
if (!auxpar("hff","s",label,files[i2])) strcpy(label,"-1");
if (strcmp(label,"-1")){
strcpy(keys,"yes");
for(i1=0;i1<count2;i1++){
  if(!strcmp("keys",left[i1])) strcpy(keys,right[i1]); 
}

    ierr=sep_get_number_keys(files[i2],&n1h);
    if(keys[0]=='y'){
	
        maxkeys=n1h;
        for(i1=0;i1<count2;i1++){
          if(!strcmp("maxkeys",left[i1])){
              strcpy(temp_ch,right[i1]); 
              maxkeys=atoi(temp_ch);
           }
        }
        if(maxkeys>n1h) maxkeys=n1h;
        if (ierr==0){
            for(i1=1;i1<=maxkeys;i1++){
                ierr=sep_get_key_name(files[i2], &i1, keyname);
                ierr=sep_get_key_type(files[i2], &i1, keytype);
                fprintf(stderr,"keynumber=%d \t keytype=%s \t keyname=%s \n",
	            i1,keytype,keyname);
             }
        }
    }
    ierr=sep_get_number_header_axes(files[i2],&tempi);
    if(tempi<2){
	fprintf(stderr,
	  "Warning: SEP3d datasets should  have at least 2 axis in header file \n");
    }
   size=(double)n1h;
		n=1;
		for(i1=2; i1 <= tempi; i1++){
   		ierr=sep_get_header_axis_par(files[i2],&i1,&temp2i,&o,&d,label);
	    sprintf(charn,"%d",temp2i);
	    sprintf(charo,"%f",o);
	    sprintf(chard,"%f",d);
     fprintf(stderr,"n%d=%s \t o%d=%s \t d%d=%s \t label%d=%s \n",
		  i1,charn,i1,charo,i1,chard,i1,label);
			n=n*temp2i;
		}
   size=(double)n1h*(double)n;
   ierr=fget_header_format_tag(files[i2],temp_ch);
/*   ierr=auxpar("hff","s",temp_ch,files[i2]);*/
        ierr=filesize(temp_ch,size,4,2);
}
if (!auxpar("gff","s",label,files[i2])) strcpy(label,"-1");
if (strcmp(label,"-1")){
strcpy(grid,"yes");
for(i1=0;i1<count2;i1++){
  if(!strcmp("grid",left[i1])) strcpy(grid,right[i1]); 
}
if(grid[0] !='n'){
    ierr=sep_get_number_grid_axes(files[i2],&n_axis);
    if(ierr==0){
        fprintf(stderr,"-----------------------------------------------------------------\n");
	size=1.;
        for(i1=2;i1<=n_axis;i1++){
	  ierr=sep_get_grid_axis_par(files[i2],&i1,&n,&o,&d,label);
	  size=size*(double)n;
          fprintf(stderr,"grid axis%d \t n%d=%d \t o%d=%f \t d%d=%f \t label%d=%s \n",i1,i1,n,i1,o,i1,d,i1,label);
        }          
/*        ierr=auxpar("gff","s",temp_ch,files[i2]);*/
        ierr=fget_grid_format_tag(files[i2],temp_ch);
				ierr=auxpar("in","s",temp2_ch,temp_ch);
				if(0==strcmp("-1",temp2_ch)) fprintf(stderr,"Regular data set no associated grid values file\n");
				else ierr=filesize(temp_ch,size,4,3);
    }
}
}
if(dff_tag==1 && dodff[0]=='y'){
  fprintf(stderr,"-----------------------------------------------------------------\n");
  fprintf(stderr,"\t \t ********** %s ************ \n",dfftag);
        ierr=auxpar("sect_axis","d",&tempi,dfftag);
        ierr=auxpar("pattern","s",temp_ch,dfftag);
   fprintf(stderr,"\t Section axis=%d  \t Pattern=%s ",tempi,temp_ch);
        ierr=auxpar("nsect","d",&tempi,dfftag);
   fprintf(stderr,"\t nsect=%d\n",tempi);
         fprintf(stderr,"\t\t --------------------------------------------\n");
   for(i1=0; i1 < tempi; i1++){
        sprintf(temp_ch,"tag_sect%d",i1);
        ierr=auxpar(temp_ch,"s",temp2_ch,dfftag);
        sprintf(temp_ch,"mach_sect%d",i1);
        ierr=auxpar(temp_ch,"s",temp3_ch,dfftag);
        fprintf(stderr,"section=%d tag=%s machine=%s \n",i1,temp2_ch,temp3_ch);
   }
}
  fprintf(stderr,"-----------------------------------------------------------------\n");

}
}
return 0;
}

int filesize(temp_ch,size,esize,type)
char temp_ch[STRING_SIZE];
int type,esize;
double size;
{
int i1,i2;
int blocksize=50000,readin;
int passes,logic,ierr,numzeros;
double over,actual_size;
float zero_pct,data_pct;
unsigned char array[50000];
char temp2_ch[STRING_SIZE];
int did_zero=1;
struct stat     buf;

/* type= 1 data file
         2 header file
         3 grid file
*/

size=size*esize;

ierr=auxpar("in","s",temp2_ch,temp_ch);
if(0>ierr){
    if(type==1) fprintf(stderr,"Can't find data in marker %s %d\n",temp2_ch,ierr);
    else if(type==2) fprintf(stderr,"Can't find header file\n");
    else if(type==3) fprintf(stderr,"Can't find grid file\n");
}
else{
    if(type==1) fprintf(stderr,"Data: in=%s \n",temp2_ch);
    if(type==2) fprintf(stderr,"Headers in=%s \n",temp2_ch);
    if(type==3) fprintf(stderr,"Grid   in=%s \n",temp2_ch);

 if(dff_tag==1){
     fprintf(stderr,"Distributed tag so no size info\n");
 }
 else if( auxin(temp_ch)==0 ){
     fprintf(stderr,"Binary file does not exist\n");
 }
  else{
    actual_size=(double)esize * (double)ssize_block(temp_ch,esize); 
    passes=size/(double)blocksize+.99999999;
    over=size-(double)(passes-1)*(double)blocksize;
    numzeros=0;
    logic=0;
    if(actual_size > 50000000){ logic=1; did_zero=0;}
    if(zero_check[0]=='n') {logic=1; did_zero=0;}
    for (i2=0;i2<passes;i2++){
      if(i2==(passes-1)) readin=(int)over;
      else readin=(int)blocksize;
      if(logic==0){
        ierr=sreed_raw(temp_ch,array,readin);
	    for(i1=0;i1<readin;i1++){
 	      if(logic==0){
	       if(array[i1]) logic=1;
               else {
/*            fprintf(stderr,"i1=%d i2=%d %c \n",i1,i2,array[i1]);*/
		numzeros=i1+i2* blocksize;
               }
	     }
            }
        }
     }
   zero_pct=100. * numzeros / actual_size;
   data_pct=100. * actual_size / (size);
   if(data_pct!=100.){
     fprintf(stderr,"%.1f%% of %11.f bytes \n",data_pct,size);
     if(did_zero==1&& zero_pct>10.0) fprintf(stderr,"The first %.1f%% of the data is zeros \n",zero_pct);
   }
   else if(zero_pct >10.0 && did_zero==1) {
	fprintf(stderr,"The first %.1f%% of %11.f bytes are zeros \n",zero_pct,size);
      }
   else fprintf(stderr,"%11.f elements, %11.f bytes in data file \n",size/(double)esize,size);
   }
  }
return 0;
}


